;=============================================
;    162
;  - 4
; :   (. )
; : 1.00
; E-mail: vladpage@rambler.ru
;=============================================
	list      p=16F84a
	#include  <p16F84a.inc>
	__CONFIG   _CP_ON & _WDT_OFF & _PWRTE_ON & _HS_OSC
;=============================================
IndF	equ	00h
Timer0	equ	01h
OptionR	equ	01h
PC	equ	02h
Status	equ	03h
FSR	equ	04h
PortA	equ	05h
TrisA	equ	05h
PortB	equ	06h
TrisB	equ	06h 
IntCon	equ	0Bh
Opt	equ	0Ch	;
Count	equ	0Dh	; 
Count2	equ	0Eh	; 
LED0	equ	10h	;  
LED1	equ	11h
LED2	equ	12h
LED3	equ	13h 
LED4	equ	14h 
LED5	equ	15h
LED6	equ	16h
LED7	equ	17h
LED8	equ	20h
LED9	equ	21h
LED10	equ	22h
LED11	equ	23h 
Zer	equ	27h 	;
Zer2	equ	28h 	;  
Zer3	equ	29h 	; . 
IFL	equ	2Ah	;  
IFM	equ	2Bh	; 
IFH	equ	2Ch
IFHH	equ	2Dh
Opt2	equ	2Fh	;
Temp	equ	18h	; 
LEDtemp	equ	19h	; LED
TimerL	equ	1Ah	;   
TimerM	equ	1Bh	;   
TimerH	equ	1Ch	;   
TimerHH	equ	1Dh	;    
NDot1	equ	1Eh	; 
NDot2	equ	1Fh 	; 
;=============================================
;  
;=============================================
RS	equ	0
E	equ	1		      
Pit	equ	2
;=============================================
;  B
;=============================================
Off	equ	0
Time	equ	1
Umn	equ	2	
Hold	equ	3		 
;=============================================
;Opt,2 = 0 : 1000, Opt,2 = 1 : 1	;  
;Opt,0 = 0, Opt,1 = 0 : 1 c
;Opt,0 = 0, Opt,1 = 1 : 10 c
;Opt,0 = 1, Opt,1 = 0 : 0.1 c
;=============================================
	org	0h
	goto	Start
;=============================================
;
;=============================================
Start
	bsf	Status,5
	movlw	b'00100111'	; 1:256,  
	movwf	OptionR   
	bcf	Status,5  
        movlw	.180		;   (  .)
        movwf	Zer
        movlw	.19
        movwf	Zer2
        movlw	.9
        movwf	Zer3
        movlw	0h		;   EEPROM
 	call	SetRD
        movwf	Opt
        call	Clear
	clrf	PortA
	clrf	PortB
	bsf	PortA,Pit
	clrf	IFHH
	clrf	IFH
	clrf	IFM
	clrf	IFL
	clrf	Opt2
	call	Pausem
; ******************************************************************************
; ****************                ****************
;        movlw   0x30         ;    8-  
;       movwf	PortB        ;     B
;        call	Enbl         ;     
;        call	Pausem       ;   Pausem   ~5,5 
;        call	Pausem
;        call	Pausem
;  B    0x30   
;        call	Enbl         ;   8-  
;        call	Pause25      ;   ,    >100 
;  B     0x30   
;        call	Enbl         ;   8-  
;        movlw   0x20         ;    4-  
;        movwf	PortB        ;     B
;        call	Enbl         ;     
;          
;   LEDcom  
;       movlw   0x28       ;  4 .  2  57 
;        call	LEDcom
; ****************       ****************
; ******************************************************************************
	movlw	b'00000010'	; 
	call	LEDcom
	movlw	b'00101000'	;    - movlw	b'00000001'
	call	LEDcom
	call	Pausem
	movlw	b'00001100'	
	call	LEDcom

	movlw	b'10000011'	;   
	call	LEDcom		;""
	movlw	' '-30h	;7Bh		
	call	LEDdata
	movlw	' '-30h	;11h	
	call	LEDdata
	movlw	'C'-30h	;13h	
	call	LEDdata
	movlw	'O'-30h	;24h	
	call	LEDdata
	movlw	'U'-30h	;1Fh	
	call	LEDdata
	movlw 	'N'-30h	;24h	
	call	LEDdata
	movlw	'T'-30h	;1Fh	
	call	LEDdata
	movlw	'E'-30h	;1Dh	
	call	LEDdata
	movlw	'R'-30h	;15h	
	call	LEDdata
	movlw	' '-30h	;20h	
	call	LEDdata

	movlw	b'11000010'	;   
	call	LEDcom		;: 1.00 
	movlw	' '-30h	;12h	
	call	LEDdata
	movlw	' '-30h	;15h	
	call	LEDdata
	movlw	'V'-30h	;20h	
	call	LEDdata
	movlw	'e'-30h	;13h	
	call	LEDdata
	movlw	'r'-30h	;75h	
	call	LEDdata
	movlw	' '-30h	;81h	
	call	LEDdata
	movlw	0Ah	
	call	LEDdata
	movlw	-10h	
	call	LEDdata
	movlw	01h	
	call	LEDdata
	movlw	-02h	
	call	LEDdata
	movlw	00h	
	call	LEDdata
	call	LEDdata

Offv	call	Pausem
	btfsc	PortB,Off	; 
	goto	Offv		; 

	movlw	b'00000001'	;   
	call	LEDcom
	call	Pausem
;=============================================
Go	call	Bin2LCD

	bcf	Status,2	; 
	addwf	TimerHH,w	;  
	btfss	Status,2
	goto	ContinZer
	addwf	TimerH,w
	btfss	Status,2
	goto	ContinZer
	addwf	TimerL,w
	btfss	Status,2
	goto	ContinZer
	addwf	TimerM,w
	btfss	Status,2
	goto	ContinZer

        btfsc   Opt,0		; 		
	goto	Zer0_1		;  
        btfsc   Opt,1		;
	goto	Zer10

	decfsz	Zer,1
	goto	ContinZer2
	goto	Stop
Zer10	
	decfsz	Zer2,1
	goto	ContinZer2
	goto	Stop
Zer0_1	
	decfsz	Zer,1
	goto	ContinZer2
	decfsz	Zer3,1
	goto	Zer0_1_2
	goto	Stop
Zer0_1_2
	movlw	.180
        movwf	Zer
	goto	ContinZer2

Stop	
	btfsc	PortB,Off	;  
	goto	Stop		; 

Stop2	bcf	PortA,Pit	; 
	goto	Stop2

ContinZer
        movlw	.180		;   (  .)
        movwf	Zer
        movlw	.19
        movwf	Zer2
        movlw	.9
        movwf	Zer3

ContinZer2
	call	Vyvod		;   

	movlw	b'11000000'	;  2- 
	call	LEDcom		;  
	movlw   'M'-30h	;78h		;  
	call LEDdata
	movlw   'e'-30h	;11h	
	call LEDdata
	movlw   'm'-30h	;1Dh	
	call LEDdata
	movlw	'o'-30h	;
	call	LEDdata
	movlw	-10h
	call	LEDdata

        btfss   Opt,2
	goto	NU1000

	movlw	-10h	
	call	LEDdata
	call	LEDdata
	movlw   48h	
	call	LEDdata
	movlw   1h	
	call	LEDdata
	movlw	-10h	
	call	LEDdata
	call	LEDdata
	call	LEDdata
	call	LEDdata
	goto	Tim
NU1000
	movlw   48h	
	call	LEDdata
	movlw   1h	
	call	LEDdata
	movlw   0h	
	call	LEDdata
	call	LEDdata
	call	LEDdata
	movlw	-10h	
	call	LEDdata
	call	LEDdata

Tim     movlw	b'11001100'	; 2- 
	call	LEDcom		

	btfss   Opt,0
	goto	Ntim1

	movlw   0h		;  
	call	LEDdata
	movlw   -02h	
	call	LEDdata
	movlw   1h	
	call	LEDdata
	goto	Perev

Ntim1	btfsc   Opt,1
	goto	Ntim10

	movlw	-10h	
	call	LEDdata
	movlw   1h	
	call	LEDdata
	movlw	-10h	
	call	LEDdata
	goto	Perev
Ntim10
	movlw   1h	
	call	LEDdata
	movlw   0h	
	call	LEDdata
	movlw	-10h	
	call	LEDdata
Perev	
	movlw	33h		;'c'
	call	LEDdata

	call	Clear
;=============================================
; .
;=============================================
        bsf	Status,5
        movlw	b'00011000' ; RA0..RA2:  ,RA3..RA4: 
        movwf	TrisA
        bcf	Status,5
;=============================================
;  .
;=============================================
        btfsc   Opt,0
	goto	P0_1
        btfsc   Opt,1
	goto	P10

        movlw   .126		;  1 
        movwf   Count        
Pause2  movlw   .255
        movwf   Temp
Pause1  
	call	provtmr		;   
	call	Key		; 
	decfsz  Temp,1
        goto    Pause1
	nop
	decfsz  Count,1
        goto    Pause2
	nop
        movlw   .95		
        movwf   Temp
Pause9
	call	provtmr		;   
	call	provtmr
	decfsz  Temp,1
        goto    Pause9
	goto	Izmerend
P0_1				;  0.1 
        movlw   .12		
        movwf   Count        
Pause4  
	movlw   .255
        movwf   Temp
Pause5  
	call	provtmr		;   
	call	Key
	decfsz  Temp,1
        goto    Pause5
	nop
	decfsz  Count,1
        goto    Pause4
	nop
        movlw   .253
        movwf   Temp
Pause8  
	call	provtmr		;   
	nop
	decfsz  Temp,1
        goto    Pause8
	nop
	nop
	nop
	nop
	nop
	nop
	goto	Izmerend
P10				;  10 
        movlw   .10		
        movwf   Count2       
Pause   movlw   .126		
        movwf   Count        
Pause6  movlw   .255
        movwf   Temp
Pause7  
	call	provtmr		;   
	call	Key
	decfsz  Temp,1
        goto    Pause7
	nop
	decfsz  Count,1
        goto    Pause6
	nop
	decfsz  Count2,1
	goto    Pause
	nop
        movlw   .12		
        movwf   Count2       
Pause13
        movlw   .146		
        movwf   Temp
Pause3  
	call	provtmr		;   
	decfsz  Temp,1
        goto    Pause3
	decfsz  Count2,1
	goto    Pause13
Izmerend
	nop
	nop
;=============================================
; .
;=============================================
        bsf	Status,5
        movlw	b'00010000'	;RA4-
        movwf	TrisA        
        bcf	Status,5
;=============================================
	call	provtmr		;    
;=============================================
;   .
;=============================================
	movf	Timer0,w	; 
	movwf	TimerM		;  TimerM
	clrf	TimerL
Cont	incf	TimerL,F	; 
	bsf	PortA,3		;    
	bcf	PortA,3		; TimerL
	nop
	movf	Timer0,w 
	bcf	Status,2
	subwf	TimerM,w
	btfsc	Status,2
	goto	Cont
	comf	TimerL,F
	incf	TimerL,F
	goto	Go
;=============================================
; TMR0  .
;=============================================
provtmr
	btfss	IntCon,2	; 
        goto	Paus		;,   
	movlw	0FFh           	;    
	bcf	Status,2	;TimerH=0FFh
	subwf	TimerH,w
	btfss	Status,2
       	goto	No    
	incf	TimerHH,F	; ,  
	clrf	TimerH		;TimerHH   
	bcf	IntCon,2	; TimerH
	goto	ret		
No      incf	TimerH,F
	bcf	IntCon,2
        goto	ret
Paus    nop
        nop
        nop
	nop
	nop
	nop
	nop
	nop
	nop
ret
	return
;=============================================
;   .
;=============================================
LEDdata	
	bsf	PortA,RS	;1   RS 
	movwf	LEDtemp		;   
	addlw	30h		;    
	movwf	PortB		;    
	call	Enbl
	movf	LEDtemp,w
	addlw	30h
	movwf	Temp
	swapf	Temp,w 
	movwf	PortB		;    
	call	Enbl
	movf	LEDtemp,w
	return
;=============================================
;   .
;=============================================
LEDcom				
	bcf	PortA,RS	;0   RS 
	movwf	LEDtemp
	movwf	PortB		;    
	call	Enbl
	movf 	LEDtemp,w
	movwf	Temp
	swapf	Temp,w 		; 
	movwf	PortB		;    
	call	Enbl
	return
;=============================================
; .
;=============================================
Key				
	btfss	PortB,Time
	goto	N1
	btfss	PortB,Hold
	goto	N2
	btfss	PortB,Umn
	goto	N3
	btfsc	PortB,Off
	goto	N4
	return
;=============================================
N1	btfsc	Opt2,3		; 
	goto	N1MemZ		; SB2

	btfsc	Opt,0
	goto	N1_1
	btfsc	Opt,1
	goto	N1_2
	bsf	Opt,1
	goto	NE1
N1_1
	bcf	Opt,0
	goto	NE1
N1_2
	bcf	Opt,1
	bsf	Opt,0
NE1
	movf	Opt,w		;  EEPROM  
	movwf   EEDATA		; 
	movlw   0h
	movwf   EEADR
	call	write
	call	Pausbig
NE1_1
	btfss	PortB,Time
	goto	NE1_1
	call	Clear
	call	Pausem
	goto	ContinZer

N1MemZ
	btfss	PortB,Time
	goto	N1MemZ

        movlw	.245		;  
        movwf	Zer
        movlw	.4	
        movwf	Zer2

	bcf	Opt,7
	btfsc	Opt,2	
	bsf	Opt,7

	bcf	Opt,6
	btfsc	Opt,1	
	bsf	Opt,6

	bcf	Opt,5
	btfsc	Opt,0	
	bsf	Opt,5

	movf	Opt,w
	movwf   EEDATA
	movlw   0h
	movwf   EEADR
	call	write

	movf	IFHH,w		;  EEPROM 
	movwf   EEDATA		;
	movlw   03h
	movwf   EEADR
	call	write
	movf	IFH,w
	movwf   EEDATA
	movlw   04h
	movwf   EEADR
	call	write
	movf	IFM,w
	movwf   EEDATA
	movlw   05h
	movwf   EEADR
	call	write
	movf	IFL,w
	movwf   EEDATA
	movlw   06h
	movwf   EEADR
	call	write
	goto	N2_2
;=============================================
N2
        movlw	.245		;  
        movwf	Zer
        movlw	.4
        movwf	Zer2

	call	Pausem
	btfss	PortB,Hold
	goto	N2

 	btfsc	Opt2,3		; 
	goto	N2MemE		; SB4

	bsf	Opt2,3
	call	LCDMem

N2_2	
	call	Key

	call	Pausbig
	decfsz	Zer,1
	goto	N2_2

	decfsz	Zer2,1
	goto	Zer111

	goto	Stop2
Zer111
        movlw	.245
        movwf	Zer
	goto	N2_2
N2MemE
	bcf	Opt2,3
	call	Clear
	goto	ContinZer
;=============================================
N3	btfsc	Opt2,3		; 
	goto	N3MemS		; SB3

	btfsc	Opt,2
	goto	N3_1
	bsf	Opt,2
	goto	NE3
N3_1
	bcf	Opt,2
	goto	NE3
NE3
	movf	Opt,w
	movwf   EEDATA
	movlw   0h
	movwf   EEADR
	call	write
	call	Pausbig
NE3_1
	btfss	PortB,Umn
	goto	NE3_1
	call	Clear
	call	Pausem
	goto	ContinZer

N3MemS
	btfss	PortB,Umn
	goto	N3MemS

        movlw	.245
        movwf	Zer
        movlw	.4
        movwf	Zer2

	call	Clear		;  EEPROM 
        movlw	03h		;
	call	SetRD
	movwf	TimerHH
        movlw	04h
	call	SetRD
	movwf	TimerH
	movlw	05h
	call	SetRD
	movwf	TimerM
	movlw	06h
	call	SetRD
 	movwf	TimerL

	movlw	0h
	call	SetRD
	movwf	Opt
	bcf	Opt,2
	btfsc	Opt,7
	bsf	Opt,2
	bcf	Opt,1
	btfsc	Opt,6
	bsf	Opt,1
	bcf	Opt,0
	btfsc	Opt,5
	bsf	Opt,0

	call	Bin2LCD
	call	Vyvod
	goto	N2_2
;=============================================
N4
	goto	Stop
;=============================================
;   EEPROM.
;=============================================
SetRD	movwf	EEADR		;  W  EEADR
	bsf	Status,5
	bsf	EECON1,RD  
	bcf	Status,5
 	movf	EEDATA,w	;  EEDATA  W
	return
;=============================================
; -.
;=============================================
Enbl	bsf	PortA,E		;1   E 
	nop			;
	bcf	PortA,E		;0   E 
;    Pause25,   . 
Pause25	movlw	.25		;
	movwf	Temp
Paus2   
	decfsz  Temp,f
	goto    Paus2
	return
;=============================================
; .
;=============================================
Pausem			
	movlw	.255
	movwf	Temp
Pausm2   
	nop
	nop
	nop
	nop
	decfsz  Temp,f
	goto    Pausm2
	return
;=============================================
; .
;=============================================
Pausbig	
	movlw   .255		
        movwf   Count        
Pause15	
	btfsc	PortB,Off
	goto	Stop
	movlw   .255
        movwf   Temp
Pause14	
	decfsz  Temp,1
        goto    Pause14
	decfsz  Count,1
        goto    Pause15
	return
;=============================================
;  EEPROM.
;=============================================
write	bsf	Status,5
	bsf	EECON1,WREN	; 
	bcf	EECON1,EEIF
	movlw	055h
	movwf	EECON2
	movlw	0AAh
	movwf	EECON2
	bsf	EECON1,WR
wee    	btfss	EECON1,EEIF	;  
	goto	wee
	bcf	EECON1,WREN	; 
        bcf	Status,5
	return
;=============================================
;      .
;=============================================
LCDMem
	movlw	b'11000000'	;  2- 
	call	LEDcom
	movlw   'E'-30h	;12h		; ""
	call LEDdata
	movlw   'x'-30h	;7Eh	
	call LEDdata
	movlw   'i'-30h	;28h	
	call LEDdata
	movlw   't'-30h	;1Fh	
	call LEDdata
	movlw   ' '-30h	;0B0h	
	call LEDdata
	movlw   -10h	
	call LEDdata
	movlw   'L'-30h	;13h		; ""
	call LEDdata
	movlw   'o'-30h	;7Bh	
	call LEDdata
	movlw   'a'-30h	;75h	
	call LEDdata
	movlw   'd'-30h	;24h	
	call LEDdata
	movlw   -10h	
	call LEDdata
	movlw   ' '-30h	;74h		; ""
	call LEDdata
	movlw   'S'-30h	;11h	
	call LEDdata
	movlw   'a'-30h	;78h	
	call LEDdata
	movlw   'v'-30h	;1Fh	
	call LEDdata
	movlw   'e'-30h	;1Dh	
	call LEDdata
	return
;=============================================
; .
;=============================================
Clear
        bsf        Status,5
        movlw      b'00010000'
        movwf      TrisA
        movlw      b'00001111'
        movwf      TrisB
        bcf        Status,5
	bcf	   PortA,3
        clrf       LED0
        clrf       LED1
	clrf       LED2		
        clrf       LED3
        clrf       LED4
        clrf       LED5
        clrf       LED6
        clrf       LED7
        clrf       LED8
        clrf       LED9
        clrf       TimerL      ;  
        clrf       TimerM
        clrf       TimerH
        clrf       TimerHH
        clrf       IntCon      ;   
	clrf       Timer0      ;  
	retlw	0
;=============================================
;    : ..
;=============================================
Contin0_1
	movlw	-10h	
	call	LEDdata
	call	LEDdata
	movf 	LED7,w
	call	LEDdata
	movf 	LED6,w
	call	LEDdata
	movf 	LED5,w
	call	LEDdata
	movf 	NDot2,w
	call	LEDdata
	movf 	LED4,w
	call	LEDdata
	movf 	LED3,w
	call	LEDdata
	movf 	LED2,w
	call	LEDdata
	movf 	NDot1,w
	call	LEDdata
	movf 	LED1,w
	call	LEDdata
	goto Str2
;=============================================
;    : ...
;=============================================
Contin10
	movf 	LED8,w
	call	LEDdata
	movf 	LED7,w
	call	LEDdata
	movf 	NDot2,w
	call	LEDdata
	movf 	LED6,w
	call	LEDdata
	movf 	LED5,w
	call	LEDdata
	movf 	LED4,w
	call	LEDdata
	movf 	NDot1,w
	call	LEDdata
	movf 	LED3,w
	call	LEDdata
	movf 	LED2,w
	call	LEDdata
	movf 	LED1,w
	call	LEDdata
	movlw   -02h		
	call	LEDdata
	goto	Str2
;=============================================
;    : ..
;=============================================
Contin1
	movlw	-10h	
	call	LEDdata
	call	LEDdata
	movf 	LED7,w
	call	LEDdata
	movf 	LED6,w
	call	LEDdata
	movf 	NDot2,w
	call	LEDdata
	movf 	LED5,w
	call	LEDdata
	movf 	LED4,w
	call	LEDdata
	movf 	LED3,w
	call	LEDdata
	movf 	NDot1,w
	call	LEDdata
	movf 	LED2,w
	call	LEDdata
	movf 	LED1,w
	call	LEDdata
	goto Str2
;=============================================
;    -
;
;=============================================
Bin2LCD
	movf	TimerHH,w
	movwf	IFHH
	movf	TimerH,w
	movwf	IFH
	movf	TimerM,w
	movwf	IFM
	movf	TimerL,w
	movwf	IFL

	bcf        Status,0
        movlw      .32
        movwf      Count
	clrf       LED4
        clrf       LED3
        clrf       LED2
        clrf       LED1
        clrf       LED0
loop32
        rlf        TimerL,f
        rlf        TimerM,f
        rlf        TimerH,f
        rlf        TimerHH,f
        rlf        LED0,f
        rlf        LED1,f
        rlf        LED2,f
        rlf        LED3,f
        rlf        LED4,f
        decfsz     Count,f
        goto       adjDEC
        movfw      LED4
        andlw      0Fh
        movwf      LED8
        swapf      LED3,w
        andlw      0Fh
        movwf      LED7
        movfw      LED3
        andlw      0Fh
        movwf      LED6
        swapf      LED2,w
        andlw      0Fh
        movwf      LED5
        movfw      LED2
        andlw      0Fh
        movwf      LED4
        swapf      LED1,w
        andlw      0Fh
        movwf      LED3
        movfw      LED1
        andlw      0Fh
        movwf      LED2
        swapf      LED0,w
        andlw      0Fh
        movwf      LED1
        movfw      LED0
        andlw      0Fh
        movwf      LED0
        return
adjDEC
        movlw      LED0
        movwf      FSR
        call       adjBCD
        movlw      LED1
        movwf      FSR
	call       adjBCD
        movlw      LED2
        movwf      FSR
        call       adjBCD
        movlw      LED3
        movwf      FSR
        call       adjBCD
	movlw      LED4
        movwf      FSR
        call       adjBCD
        goto       loop32
adjBCD
        movlw      3
        addwf      0,w
        movwf      Count2
        btfsc      Count2,3
        movwf      0
        movlw      30
        addwf      0,w
        movwf      Count2
        btfsc      Count2,7
        movwf      0
        retlw      0
;=============================================
;   .    .
;=============================================
Vyvod
	movlw	b'10000000'	;  1- 
	call	LEDcom
	movlw	-02h		;'.'
	movwf	NDot1
	movwf	NDot2
	movlw   'H'-30h	;71h		;''
	movwf	LED10
        btfsc   Opt,2
	movlw   1Dh		;'M'
	movwf	LED9
	movlw	'z'-30h	;0B5h		;''
	movwf	LED11
	
	btfsc   Opt,0		;  
	goto	Out0_1		;   
        btfsc   Opt,1		; 
	goto	Out10
	goto	Out1
Out0_1
	movlw	0		;8
	bcf	Status,2	;  
	addwf	LED7,w
	btfss	Status,2
	goto	Contin0_1
	movlw   -10h		; LED='0',  LED=' '
	movwf   LED7
	movlw	0		;7
	addwf	LED6,w	;7
	btfss	Status,2
	goto	Contin0_1
	movlw   -10h
	movwf   LED6
	movlw	0		;6
	addwf	LED5,w
	btfss	Status,2
	goto	Contin0_1
	movlw   -10h
	movwf   LED5
	movwf	NDot2
	movlw   'k'-30h	;8Ah		;
        btfss   Opt,2
	movlw   1Dh		;M
	movwf   LED9
	movlw	0	
	addwf	LED4,w		;5
	btfss	Status,2
	goto	Contin0_1
	movlw   -10h
	movwf   LED4
	movlw	0	
	addwf	LED3,w		;4
	btfss	Status,2
	goto	Contin0_1
	movlw   -10h
	movwf   LED3
	goto	Contin0_1
Out10
	movlw	0		;9
	bcf	Status,2
	addwf	LED8,w
	btfss	Status,2
	goto	Contin10
	movlw   -10h
	movwf   LED8
	movlw	0		;8
	addwf	LED7,w
	btfss	Status,2
	goto	Contin10
	movlw   -10h
	movwf   LED7
	movwf	NDot2
	movlw   'k'-30h	;8Ah		;
        btfss   Opt,2
	movlw   1Dh		;M
	movwf   LED9
	movlw	0	
	addwf	LED6,w		;7
	btfss	Status,2
	goto	Contin10
	movlw   -10h
	movwf   LED6
	movlw	0		;6
	addwf	LED5,w
	btfss	Status,2
	goto	Contin10
	movlw   -10h
	movwf   LED5
	movlw	0	
	addwf	LED4,w	;5
	btfss	Status,2
	goto	Contin10
	movlw   -10h
	movwf   LED4
	movwf	NDot1
	movlw	-10h		;' ' 
        btfss   Opt,2
	movlw   'k'-30h	;8Ah		;
	movwf	LED9
	movlw	0	
	addwf	LED3,w	;4
	btfss	Status,2
	goto	Contin10
	movlw   -10h
	movwf   LED3
	movlw	0		;3
	addwf	LED2,w
	btfss	Status,2
	goto	Contin10
	movlw   -10h
	movwf   LED2
	goto	Contin10
Out1
	movlw	0		;8
	bcf	Status,2
	addwf	LED7,w
	btfss	Status,2
	goto	Contin1
	movlw   -10h
	movwf   LED7
	movlw	0	
	addwf	LED6,w		;7
	btfss	Status,2
	goto	Contin1
	movlw   -10h
	movwf   LED6
	movwf	NDot2
	movlw   'k'-30h	;8Ah		;
        btfss   Opt,2
	movlw   1Dh		;M
	movwf   LED9
	movlw	0		;6
	addwf	LED5,w
	btfss	Status,2
	goto	Contin1
	movlw   -10h
	movwf   LED5
	movlw	0	
	addwf	LED4,w		;5
	btfss	Status,2
	goto	Contin1
	movlw   -10h
	movwf   LED4
	movlw	0	
	addwf	LED3,w		;4
	btfss	Status,2
	goto	Contin1
	movlw   -10h
	movwf   LED3
	movwf	NDot1
	movlw	-10h		;' '
        btfss   Opt,2
	movlw   'k'-30h	;8Ah		;
	movwf	LED9
	movlw	0		;3
	addwf	LED2,w
	btfss	Status,2
	goto	Contin1
	movlw   -10h
	movwf   LED2
	movlw	0	
	addwf	LED1,w		;2
	btfss	Status,2
	goto	Contin1
	movlw   -10h
	movwf   LED1
	goto	Contin1
Str2
	movf 	LED0,w
	call	LEDdata
	movlw   -10h		;' '
	call	LEDdata
	movf 	LED9,w		;'' ',, , '
	call	LEDdata
	movf 	LED10,w		;''
	call	LEDdata
	movf 	LED11,w		;''
	call	LEDdata
	return
;=============================================
;  EEPROM
;=============================================
	org    2100h
	DATA   .165, 0, 0, 0, 0, 0, 0, 0
	DATA   0, 0, 0, 0, 0, 0, 0, 0
	DATA   0, 0, 0, 0, 0, 0, 0, 0
	DATA   0, 0, 0, 0, 0, 0, 0, 0
	DATA   0, 0, 0, 0, 0, 0, 0, 0
	DATA   0, 0, 0, 0, 0, 0, 0, 0
	DATA   0, 0, 0, 0, 0, 0, 0, 0
	DATA   0, 0, 0, 0, 0, 0, 0, 0
;=============================================
	end
